/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the CreateDocumentWebhook type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateDocumentWebhook{}

// CreateDocumentWebhook struct for CreateDocumentWebhook
type CreateDocumentWebhook struct {
	TransactionId string `json:"transaction_id"`
	ChannelId string `json:"channel_id"`
	ConversationId string `json:"conversation_id"`
	ContactId string `json:"contact_id"`
	Document CreateDocumentWebhookDocument `json:"document"`
}

// NewCreateDocumentWebhook instantiates a new CreateDocumentWebhook object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateDocumentWebhook(transactionId string, channelId string, conversationId string, contactId string, document CreateDocumentWebhookDocument) *CreateDocumentWebhook {
	this := CreateDocumentWebhook{}
	this.TransactionId = transactionId
	this.ChannelId = channelId
	this.ConversationId = conversationId
	this.ContactId = contactId
	this.Document = document
	return &this
}

// NewCreateDocumentWebhookWithDefaults instantiates a new CreateDocumentWebhook object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateDocumentWebhookWithDefaults() *CreateDocumentWebhook {
	this := CreateDocumentWebhook{}
	return &this
}

// GetTransactionId returns the TransactionId field value
func (o *CreateDocumentWebhook) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *CreateDocumentWebhook) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *CreateDocumentWebhook) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetChannelId returns the ChannelId field value
func (o *CreateDocumentWebhook) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *CreateDocumentWebhook) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *CreateDocumentWebhook) SetChannelId(v string) {
	o.ChannelId = v
}

// GetConversationId returns the ConversationId field value
func (o *CreateDocumentWebhook) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *CreateDocumentWebhook) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *CreateDocumentWebhook) SetConversationId(v string) {
	o.ConversationId = v
}

// GetContactId returns the ContactId field value
func (o *CreateDocumentWebhook) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *CreateDocumentWebhook) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *CreateDocumentWebhook) SetContactId(v string) {
	o.ContactId = v
}

// GetDocument returns the Document field value
func (o *CreateDocumentWebhook) GetDocument() CreateDocumentWebhookDocument {
	if o == nil {
		var ret CreateDocumentWebhookDocument
		return ret
	}

	return o.Document
}

// GetDocumentOk returns a tuple with the Document field value
// and a boolean to check if the value has been set.
func (o *CreateDocumentWebhook) GetDocumentOk() (*CreateDocumentWebhookDocument, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Document, true
}

// SetDocument sets field value
func (o *CreateDocumentWebhook) SetDocument(v CreateDocumentWebhookDocument) {
	o.Document = v
}

func (o CreateDocumentWebhook) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateDocumentWebhook) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["contact_id"] = o.ContactId
	toSerialize["document"] = o.Document
	return toSerialize, nil
}

type NullableCreateDocumentWebhook struct {
	value *CreateDocumentWebhook
	isSet bool
}

func (v NullableCreateDocumentWebhook) Get() *CreateDocumentWebhook {
	return v.value
}

func (v *NullableCreateDocumentWebhook) Set(val *CreateDocumentWebhook) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateDocumentWebhook) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateDocumentWebhook) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateDocumentWebhook(val *CreateDocumentWebhook) *NullableCreateDocumentWebhook {
	return &NullableCreateDocumentWebhook{value: val, isSet: true}
}

func (v NullableCreateDocumentWebhook) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateDocumentWebhook) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


